ace.define("ace/mode/mips_highlight_rules",["require","exports","module","ace/lib/oop","ace/mode/text_highlight_rules"],function(o,h,p){"use strict";var f=o("../lib/oop"),c=o("./text_highlight_rules").TextHighlightRules,d=function(){var g=/\\(?:['"?\\abfnrtv]|[0-7]{1,3}|x[a-fA-F\d]{2}|u[a-fA-F\d]{4}U[a-fA-F\d]{8}|.)/.source;this.$rules={start:[{token:"storage.modifier.mips",regex:/\.\b(?:align|ascii|asciiz|byte|double|extern|float|globl|space|word)\b/,comment:"Assembler directives for data storage"},{token:"entity.name.section.mips",regex:/\.\b(?:data|text|kdata|ktext|)\b/,comment:"Segements: .data .text"},{token:"variable.parameter.mips",regex:/\$(?:(?:3[01]|[12]?[0-9]|[0-9])|zero|at|v[01]|a[0-3]|s[0-7]|t[0-9]|k[01]|gp|sp|fp|ra)/,comment:"Registers by id $1, $2, ..."},{token:"variable.parameter.mips",regex:/\$f(?:[0-9]|[1-2][0-9]|3[0-1])/,comment:"Floating point registers"},{token:"support.function.source.mips",regex:/\b(?:(?:add|sub|div|l|mov|mult|neg|s|c\.eq|c\.le|c\.lt)\.[ds]|cvt\.s\.[dw]|cvt\.d\.[sw]|cvt\.w\.[ds]|bc1[tf])\b/,comment:"The MIPS floating-point instruction set"},{token:"support.function.source.mips",regex:/\b(?:add|addu|addi|addiu|sub|subu|and|andi|or|not|ori|nor|xor|xori|slt|sltu|slti|sltiu|sll|sllv|rol|srl|sra|srlv|ror|j|jr|jal|beq|bne|lw|sw|lb|sb|lui|move|mfhi|mflo|mthi|mtlo)\b/,comment:"Just the hardcoded instructions provided by the MIPS assembly language"},{token:"support.function.other.mips",regex:/\b(?:abs|b|beqz|bge|bgt|bgtu|ble|bleu|blt|bltu|bnez|div|divu|la|li|move|mul|neg|not|rem|remu|seq|sge|sgt|sle|sne)\b/,comment:"Pseudo instructions"},{token:"entity.name.function.mips",regex:/\bsyscall\b/,comment:"Other"},{token:"string",regex:"(?:'\")(?:"+g+"|.)?(?:'\")"},{token:"string.start",regex:"'",stateName:"qstring",next:[{token:"string",regex:/\\\s*$/,next:"qqstring"},{token:"constant.language.escape",regex:g},{token:"string.end",regex:"'|$",next:"start"},{defaultToken:"string"}]},{token:"string.start",regex:'"',stateName:"qqstring",next:[{token:"string",regex:/\\\s*$/,next:"qqstring"},{token:"constant.language.escape",regex:g},{token:"string.end",regex:'"|$',next:"start"},{defaultToken:"string"}]},{token:"constant.numeric.mips",regex:/\b(?:\d+|0(?:x|X)[a-fA-F0-9]+)\b/,comment:"Numbers like +12, -3, 55, 0x3F"},{token:"entity.name.tag.mips",regex:/\b[\w]+\b:/,comment:"Labels at line start: begin_repeat: add ..."},{token:"comment.assembly",regex:/#.*$/,comment:"Single line comments"}]},this.normalizeRules()};d.metaData={fileTypes:["s","asm"],name:"MIPS",scopeName:"source.mips"},f.inherits(d,c),h.MIPSHighlightRules=d}),ace.define("ace/mode/folding/cstyle",["require","exports","module","ace/lib/oop","ace/range","ace/mode/folding/fold_mode"],function(o,h,p){"use strict";var f=o("../../lib/oop"),c=o("../../range").Range,d=o("./fold_mode").FoldMode,g=h.FoldMode=function(e){e&&(this.foldingStartMarker=new RegExp(this.foldingStartMarker.source.replace(/\|[^|]*?$/,"|"+e.start)),this.foldingStopMarker=new RegExp(this.foldingStopMarker.source.replace(/\|[^|]*?$/,"|"+e.end)))};f.inherits(g,d),function(){this.foldingStartMarker=/([\{\[\(])[^\}\]\)]*$|^\s*(\/\*)/,this.foldingStopMarker=/^[^\[\{\(]*([\}\]\)])|^[\s\*]*(\*\/)/,this.singleLineBlockCommentRe=/^\s*(\/\*).*\*\/\s*$/,this.tripleStarBlockCommentRe=/^\s*(\/\*\*\*).*\*\/\s*$/,this.startRegionRe=/^\s*(\/\*|\/\/)#?region\b/,this._getFoldWidgetBase=this.getFoldWidget,this.getFoldWidget=function(e,t,i){var a=e.getLine(i);if(this.singleLineBlockCommentRe.test(a)&&!this.startRegionRe.test(a)&&!this.tripleStarBlockCommentRe.test(a))return"";var r=this._getFoldWidgetBase(e,t,i);return!r&&this.startRegionRe.test(a)?"start":r},this.getFoldWidgetRange=function(e,t,i,a){var n,r=e.getLine(i);if(this.startRegionRe.test(r))return this.getCommentRegionBlock(e,r,i);if(n=r.match(this.foldingStartMarker)){var l=n.index;if(n[1])return this.openingBracketBlock(e,n[1],i,l);var s=e.getCommentFoldRange(i,l+n[0].length,1);return s&&!s.isMultiLine()&&(a?s=this.getSectionRange(e,i):"all"!=t&&(s=null)),s}return"markbegin"!==t&&(n=r.match(this.foldingStopMarker))?(l=n.index+n[0].length,n[1]?this.closingBracketBlock(e,n[1],i,l):e.getCommentFoldRange(i,l,-1)):void 0},this.getSectionRange=function(e,t){for(var i=e.getLine(t),a=i.search(/\S/),r=t,l=i.length,s=t+=1,n=e.getLength();++t<n;){var u=(i=e.getLine(t)).search(/\S/);if(-1!==u){if(a>u)break;var m=this.getFoldWidgetRange(e,"all",t);if(m){if(m.start.row<=r)break;if(m.isMultiLine())t=m.end.row;else if(a==u)break}s=t}}return new c(r,l,s,e.getLine(s).length)},this.getCommentRegionBlock=function(e,t,i){for(var a=t.search(/\s*$/),r=e.getLength(),l=i,s=/^\s*(?:\/\*|\/\/|--)#?(end)?region\b/,n=1;++i<r;){t=e.getLine(i);var u=s.exec(t);if(u&&(u[1]?n--:n++,!n))break}if(i>l)return new c(l,a,i,t.length)}}.call(g.prototype)}),ace.define("ace/mode/mips",["require","exports","module","ace/lib/oop","ace/mode/text","ace/mode/mips_highlight_rules","ace/mode/folding/cstyle"],function(o,h,p){"use strict";var f=o("../lib/oop"),c=o("./text").Mode,d=o("./mips_highlight_rules").MIPSHighlightRules,g=o("./folding/cstyle").FoldMode,e=function(){this.HighlightRules=d,this.foldingRules=new g};f.inherits(e,c),function(){this.lineCommentStart=["#"],this.$id="ace/mode/mips"}.call(e.prototype),h.Mode=e}),ace.require(["ace/mode/mips"],function(o){"object"==typeof module&&"object"==typeof exports&&module&&(module.exports=o)});