ace.define("ace/mode/doc_comment_highlight_rules",["require","exports","module","ace/lib/oop","ace/mode/text_highlight_rules"],function(r,u,P){"use strict";var _=r("../lib/oop"),g=r("./text_highlight_rules").TextHighlightRules,a=function(){this.$rules={start:[{token:"comment.doc.tag",regex:"@[\\w\\d_]+"},a.getTagRule(),{defaultToken:"comment.doc",caseInsensitive:!0}]}};_.inherits(a,g),a.getTagRule=function(s){return{token:"comment.doc.tag.storage.type",regex:"\\b(?:TODO|FIXME|XXX|HACK)\\b"}},a.getStartRule=function(s){return{token:"comment.doc",regex:"\\/\\*(?=\\*)",next:s}},a.getEndRule=function(s){return{token:"comment.doc",regex:"\\*\\/",next:s}},u.DocCommentHighlightRules=a}),ace.define("ace/mode/scrypt_highlight_rules",["require","exports","module","ace/lib/oop","ace/mode/doc_comment_highlight_rules","ace/mode/text_highlight_rules"],function(r,u,P){"use strict";var _=r("../lib/oop"),g=r("./doc_comment_highlight_rules").DocCommentHighlightRules,a=r("./text_highlight_rules").TextHighlightRules,s=function(){var o=this.createKeywordMapper({"variable.language":"this",keyword:"contract|library|loop|new|private|public|if|else|struct|type|require|static|const|import|exit|return|asm","constant.language":"true|false","support.function":"function|auto|constructor|bytes|int|bool|SigHashPreimage|PrivKey|PubKey|Sig|Ripemd160|Sha1|Sha256|SigHashType|SigHashPreimage|OpCodeType"},"identifier");this.$rules={start:[{token:"comment",regex:"\\/\\/.*$"},g.getStartRule("doc-start"),{token:"comment",regex:"\\/\\*",next:"comment"},{token:"string",regex:'["](?:(?:\\\\.)|(?:[^"\\\\]))*?["]'},{token:"string",regex:"['](?:(?:\\\\.)|(?:[^'\\\\]))*?[']"},{token:"constant.numeric",regex:/0(?:[xX][0-9a-fA-F][0-9a-fA-F_]*|[bB][01][01_]*)[LlSsDdFfYy]?\b/},{token:"constant.numeric",regex:/[+-]?\d[\d_]*(?:(?:\.[\d_]*)?(?:[eE][+-]?[\d_]+)?)?[LlSsDdFfYy]?\b/},{token:"constant.language.boolean",regex:"(?:true|false)\\b"},{token:["support.function.math.scrypt","text","text"],regex:/\b(abs|min|max|within|ripemd160|sha1|sha256|hash160|hash256|checkSig|checkMultiSig|num2bin|pack|unpack|len|reverseBytes|repeat)(\s*)(\()/},{token:["entity.name.type.scrypt","text","text","text","variable.object.property.scrypt"],regex:/\b(SigHash)(\s*)(\.)(\s*)(ANYONECANPAY|ALL|FORKID|NONE|SINGLE)\b/},{token:["entity.name.type.scrypt","text","text","text","variable.object.property.scrypt"],regex:/\b(OpCode)(\s*)(\.)(\s*)(OP_PUSHDATA1|OP_PUSHDATA2|OP_PUSHDATA4|OP_0|OP_FALSE|OP_1NEGATE|OP_1|OP_TRUE|OP_2|OP_3|OP_4|OP_5|OP_6|OP_7|OP_8|OP_9|OP_10|OP_11|OP_12|OP_13|OP_14|OP_15|OP_16|OP_1ADD|OP_1SUB|OP_NEGATE|OP_ABS|OP_NOT|OP_0NOTEQUAL|OP_ADD|OP_SUB|OP_MUL|OP_DIV|OP_MOD|OP_LSHIFT|OP_RSHIFT|OP_BOOLAND|OP_BOOLOR|OP_NUMEQUAL|OP_NUMEQUALVERIFY|OP_NUMNOTEQUAL|OP_LESSTHAN|OP_GREATERTHAN|OP_LESSTHANOREQUAL|OP_GREATERTHANOREQUAL|OP_MIN|OP_MAX|OP_WITHIN|OP_CAT|OP_SPLIT|OP_BIN2NUM|OP_NUM2BIN|OP_SIZE|OP_NOP|OP_IF|OP_NOTIF|OP_ELSE|OP_ENDIF|OP_VERIFY|OP_RETURN|OP_TOALTSTACK|OP_FROMALTSTACK|OP_IFDUP|OP_DEPTH|OP_DROP|OP_DUP|OP_NIP|OP_OVER|OP_PICK|OP_ROLL|OP_ROT|OP_SWAP|OP_TUCK|OP_2DROP|OP_2DUP|OP_3DUP|OP_2OVER|OP_2ROT|OP_2SWAP|OP_RIPEMD160|OP_SHA1|OP_SHA256|OP_HASH160|OP_HASH256|OP_CODESEPARATOR|OP_CHECKSIG|OP_CHECKSIGVERIFY|OP_CHECKMULTISIG|OP_CHECKMULTISIGVERIFY|OP_INVERT|OP_AND|OP_OR|OP_XOR|OP_EQUAL|OP_EQUALVERIFY)\b/},{token:"entity.name.type.scrypt",regex:/\b(?:P2PKH|P2PK|Tx|HashPuzzleRipemd160|HashPuzzleSha1|HashPuzzleSha256|HashPuzzleHash160|OpCode|SigHash)\b/},{token:["punctuation.separator.period.scrypt","text","entity.name.function.scrypt","text","punctuation.definition.parameters.begin.bracket.round.scrypt"],regex:/(\.)([^\S$\r]*)([\w][\w\d]*)(\s*)(\()/,push:[{token:"punctuation.definition.parameters.end.bracket.round.scrypt",regex:/\)/,next:"pop"},{defaultToken:"start"}]},{token:o,regex:"[a-zA-Z_$][a-zA-Z0-9_$]*\\b"},{token:"keyword.operator",regex:"!|\\$|%|&|\\||\\^|\\*|\\/|\\-\\-|\\-|\\+\\+|\\+|~|==|=|!=|<=|>=|<>|<|>|!|&&|\\|\\||\\?|\\:|\\*=|\\/=|%=|\\+=|\\-=|&=|\\|=|\\^="},{token:"lparen",regex:"[[({]"},{token:"rparen",regex:"[\\])}]"},{token:"text",regex:"\\s+"}],comment:[{token:"comment",regex:"\\*\\/",next:"start"},{defaultToken:"comment"}]},this.embedRules(g,"doc-",[g.getEndRule("start")]),this.normalizeRules()};_.inherits(s,a),u.scryptHighlightRules=s}),ace.define("ace/mode/folding/cstyle",["require","exports","module","ace/lib/oop","ace/range","ace/mode/folding/fold_mode"],function(r,u,P){"use strict";var _=r("../../lib/oop"),g=r("../../range").Range,a=r("./fold_mode").FoldMode,s=u.FoldMode=function(e){e&&(this.foldingStartMarker=new RegExp(this.foldingStartMarker.source.replace(/\|[^|]*?$/,"|"+e.start)),this.foldingStopMarker=new RegExp(this.foldingStopMarker.source.replace(/\|[^|]*?$/,"|"+e.end)))};_.inherits(s,a),function(){this.foldingStartMarker=/([\{\[\(])[^\}\]\)]*$|^\s*(\/\*)/,this.foldingStopMarker=/^[^\[\{\(]*([\}\]\)])|^[\s\*]*(\*\/)/,this.singleLineBlockCommentRe=/^\s*(\/\*).*\*\/\s*$/,this.tripleStarBlockCommentRe=/^\s*(\/\*\*\*).*\*\/\s*$/,this.startRegionRe=/^\s*(\/\*|\/\/)#?region\b/,this._getFoldWidgetBase=this.getFoldWidget,this.getFoldWidget=function(e,t,i){var o=e.getLine(i);if(this.singleLineBlockCommentRe.test(o)&&!this.startRegionRe.test(o)&&!this.tripleStarBlockCommentRe.test(o))return"";var l=this._getFoldWidgetBase(e,t,i);return!l&&this.startRegionRe.test(o)?"start":l},this.getFoldWidgetRange=function(e,t,i,o){var n,l=e.getLine(i);if(this.startRegionRe.test(l))return this.getCommentRegionBlock(e,l,i);if(n=l.match(this.foldingStartMarker)){var h=n.index;if(n[1])return this.openingBracketBlock(e,n[1],i,h);var c=e.getCommentFoldRange(i,h+n[0].length,1);return c&&!c.isMultiLine()&&(o?c=this.getSectionRange(e,i):"all"!=t&&(c=null)),c}return"markbegin"!==t&&(n=l.match(this.foldingStopMarker))?(h=n.index+n[0].length,n[1]?this.closingBracketBlock(e,n[1],i,h):e.getCommentFoldRange(i,h,-1)):void 0},this.getSectionRange=function(e,t){for(var i=e.getLine(t),o=i.search(/\S/),l=t,h=i.length,c=t+=1,n=e.getLength();++t<n;){var d=(i=e.getLine(t)).search(/\S/);if(-1!==d){if(o>d)break;var O=this.getFoldWidgetRange(e,"all",t);if(O){if(O.start.row<=l)break;if(O.isMultiLine())t=O.end.row;else if(o==d)break}c=t}}return new g(l,h,c,e.getLine(c).length)},this.getCommentRegionBlock=function(e,t,i){for(var o=t.search(/\s*$/),l=e.getLength(),h=i,c=/^\s*(?:\/\*|\/\/|--)#?(end)?region\b/,n=1;++i<l;){t=e.getLine(i);var d=c.exec(t);if(d&&(d[1]?n--:n++,!n))break}if(i>h)return new g(h,o,i,t.length)}}.call(s.prototype)}),ace.define("ace/mode/scrypt",["require","exports","module","ace/lib/oop","ace/mode/text","ace/mode/scrypt_highlight_rules","ace/mode/folding/cstyle"],function(r,u,P){"use strict";var _=r("../lib/oop"),g=r("./text").Mode,a=r("./scrypt_highlight_rules").scryptHighlightRules,s=r("./folding/cstyle").FoldMode,e=function(){this.HighlightRules=a,this.foldingRules=new s};_.inherits(e,g),function(){this.lineCommentStart="//",this.blockComment={start:"/*",end:"*/"},this.$quotes={'"':'"',"'":"'"},this.createWorker=function(t){return null},this.$id="ace/mode/scrypt"}.call(e.prototype),u.Mode=e}),ace.require(["ace/mode/scrypt"],function(r){"object"==typeof module&&"object"==typeof exports&&module&&(module.exports=r)});