ace.define("ace/mode/puppet_highlight_rules",["require","exports","module","ace/lib/oop","ace/mode/text_highlight_rules"],function(i,g,m){"use strict";var d=i("../lib/oop"),u=i("./text_highlight_rules").TextHighlightRules,r=function(){this.$rules={start:[{token:["keyword.type.puppet","constant.class.puppet","keyword.inherits.puppet","constant.class.puppet"],regex:'^\\s*(class)(\\s+(?:[-_A-Za-z0-9".]+::)*[-_A-Za-z0-9".]+\\s*)(?:(inherits\\s*)(\\s+(?:[-_A-Za-z0-9".]+::)*[-_A-Za-z0-9".]+\\s*))?'},{token:["storage.function.puppet","name.function.puppet","punctuation.lpar"],regex:"(^\\s*define)(\\s+[a-zA-Z0-9_:]+\\s*)(\\()",push:[{token:"punctuation.rpar.puppet",regex:"\\)",next:"pop"},{include:"constants"},{include:"variable"},{include:"strings"},{include:"operators"},{defaultToken:"string"}]},{token:["language.support.class","keyword.operator"],regex:"\\b([a-zA-Z_]+)(\\s+=>)"},{token:["exported.resource.puppet","keyword.name.resource.puppet","paren.lparen"],regex:"(\\@\\@)?(\\s*[a-zA-Z_]*)(\\s*\\{)"},{token:"qualified.variable.puppet",regex:"(\\$([a-z][a-z0-9_]*)?(::[a-z][a-z0-9_]*)*::[a-z0-9_][a-zA-Z0-9_]*)"},{token:"singleline.comment.puppet",regex:"#(.)*$"},{token:"multiline.comment.begin.puppet",regex:"^\\s*\\/\\*",push:"blockComment"},{token:"keyword.control.puppet",regex:"\\b(case|if|unless|else|elsif|in|default:|and|or)\\s+(?!::)"},{token:"keyword.control.puppet",regex:"\\b(import|default|inherits|include|require|contain|node|application|consumes|environment|site|function|produces)\\b"},{token:"support.function.puppet",regex:"\\b(lest|str2bool|escape|gsub|Timestamp|Timespan|with|alert|crit|debug|notice|sprintf|split|step|strftime|slice|shellquote|type|sha1|defined|scanf|reverse_each|regsubst|return|emerg|reduce|err|failed|fail|versioncmp|file|generate|then|info|realize|search|tag|tagged|template|epp|warning|hiera_include|each|assert_type|binary_file|create_resources|dig|digest|filter|lookup|find_file|fqdn_rand|hiera_array|hiera_hash|inline_epp|inline_template|map|match|md5|new|next)\\b"},{token:"constant.types.puppet",regex:"\\b(String|File|Package|Service|Class|Integer|Array|Catalogentry|Variant|Boolean|Undef|Number|Hash|Float|Numeric|NotUndef|Callable|Optional|Any|Regexp|Sensitive|Sensitive.new|Type|Resource|Default|Enum|Scalar|Collection|Data|Pattern|Tuple|Struct)\\b"},{token:"paren.lparen",regex:"[[({]"},{token:"paren.rparen",regex:"[\\])}]"},{include:"variable"},{include:"constants"},{include:"strings"},{include:"operators"},{token:"regexp.begin.string.puppet",regex:"\\s*(\\/(\\S)+)\\/"}],blockComment:[{regex:"\\*\\/",token:"multiline.comment.end.puppet",next:"pop"},{defaultToken:"comment"}],constants:[{token:"constant.language.puppet",regex:"\\b(false|true|running|stopped|installed|purged|latest|file|directory|held|undef|present|absent|link|mounted|unmounted)\\b"}],variable:[{token:"variable.puppet",regex:"(\\$[a-z0-9_{][a-zA-Z0-9_]*)"}],strings:[{token:"punctuation.quote.puppet",regex:"'",push:[{token:"punctuation.quote.puppet",regex:"'",next:"pop"},{include:"escaped_chars"},{defaultToken:"string"}]},{token:"punctuation.quote.puppet",regex:'"',push:[{token:"punctuation.quote.puppet",regex:'"',next:"pop"},{include:"escaped_chars"},{include:"variable"},{defaultToken:"string"}]}],escaped_chars:[{token:"constant.escaped_char.puppet",regex:"\\\\."}],operators:[{token:"keyword.operator",regex:"\\+\\.|\\-\\.|\\*\\.|\\/\\.|#|;;|\\+|\\-|\\*|\\*\\*\\/|\\/\\/|%|<<|>>|&|\\||\\^|~|<|>|<=|=>|==|!=|<>|<-|=|::|,"}]},this.normalizeRules()};d.inherits(r,u),g.PuppetHighlightRules=r}),ace.define("ace/mode/folding/cstyle",["require","exports","module","ace/lib/oop","ace/range","ace/mode/folding/fold_mode"],function(i,g,m){"use strict";var d=i("../../lib/oop"),u=i("../../range").Range,r=i("./fold_mode").FoldMode,p=g.FoldMode=function(e){e&&(this.foldingStartMarker=new RegExp(this.foldingStartMarker.source.replace(/\|[^|]*?$/,"|"+e.start)),this.foldingStopMarker=new RegExp(this.foldingStopMarker.source.replace(/\|[^|]*?$/,"|"+e.end)))};d.inherits(p,r),function(){this.foldingStartMarker=/([\{\[\(])[^\}\]\)]*$|^\s*(\/\*)/,this.foldingStopMarker=/^[^\[\{\(]*([\}\]\)])|^[\s\*]*(\*\/)/,this.singleLineBlockCommentRe=/^\s*(\/\*).*\*\/\s*$/,this.tripleStarBlockCommentRe=/^\s*(\/\*\*\*).*\*\/\s*$/,this.startRegionRe=/^\s*(\/\*|\/\/)#?region\b/,this._getFoldWidgetBase=this.getFoldWidget,this.getFoldWidget=function(e,n,t){var o=e.getLine(t);if(this.singleLineBlockCommentRe.test(o)&&!this.startRegionRe.test(o)&&!this.tripleStarBlockCommentRe.test(o))return"";var l=this._getFoldWidgetBase(e,n,t);return!l&&this.startRegionRe.test(o)?"start":l},this.getFoldWidgetRange=function(e,n,t,o){var a,l=e.getLine(t);if(this.startRegionRe.test(l))return this.getCommentRegionBlock(e,l,t);if(a=l.match(this.foldingStartMarker)){var c=a.index;if(a[1])return this.openingBracketBlock(e,a[1],t,c);var s=e.getCommentFoldRange(t,c+a[0].length,1);return s&&!s.isMultiLine()&&(o?s=this.getSectionRange(e,t):"all"!=n&&(s=null)),s}return"markbegin"!==n&&(a=l.match(this.foldingStopMarker))?(c=a.index+a[0].length,a[1]?this.closingBracketBlock(e,a[1],t,c):e.getCommentFoldRange(t,c,-1)):void 0},this.getSectionRange=function(e,n){for(var t=e.getLine(n),o=t.search(/\S/),l=n,c=t.length,s=n+=1,a=e.getLength();++n<a;){var f=(t=e.getLine(n)).search(/\S/);if(-1!==f){if(o>f)break;var h=this.getFoldWidgetRange(e,"all",n);if(h){if(h.start.row<=l)break;if(h.isMultiLine())n=h.end.row;else if(o==f)break}s=n}}return new u(l,c,s,e.getLine(s).length)},this.getCommentRegionBlock=function(e,n,t){for(var o=n.search(/\s*$/),l=e.getLength(),c=t,s=/^\s*(?:\/\*|\/\/|--)#?(end)?region\b/,a=1;++t<l;){n=e.getLine(t);var f=s.exec(n);if(f&&(f[1]?a--:a++,!a))break}if(t>c)return new u(c,o,t,n.length)}}.call(p.prototype)}),ace.define("ace/mode/matching_brace_outdent",["require","exports","module","ace/range"],function(i,g,m){"use strict";var d=i("../range").Range,u=function(){};(function(){this.checkOutdent=function(r,p){return!!/^\s+$/.test(r)&&/^\s*\}/.test(p)},this.autoOutdent=function(r,p){var n=r.getLine(p).match(/^(\s*\})/);if(!n)return 0;var t=n[1].length,o=r.findMatchingBracket({row:p,column:t});if(!o||o.row==p)return 0;var l=this.$getIndent(r.getLine(o.row));r.replace(new d(p,0,p,t-1),l)},this.$getIndent=function(r){return r.match(/^\s*/)[0]}}).call(u.prototype),g.MatchingBraceOutdent=u}),ace.define("ace/mode/puppet",["require","exports","module","ace/lib/oop","ace/mode/text","ace/mode/puppet_highlight_rules","ace/mode/behaviour/cstyle","ace/mode/folding/cstyle","ace/mode/matching_brace_outdent"],function(i,g,m){"use strict";var d=i("../lib/oop"),u=i("./text").Mode,r=i("./puppet_highlight_rules").PuppetHighlightRules,p=i("./behaviour/cstyle").CstyleBehaviour,e=i("./folding/cstyle").FoldMode,n=i("./matching_brace_outdent").MatchingBraceOutdent,t=function(){u.call(this),this.HighlightRules=r,this.$outdent=new n,this.$behaviour=new p,this.foldingRules=new e};d.inherits(t,u),function(){this.lineCommentStart="#",this.blockComment={start:"/*",end:"*/"},this.$id="ace/mode/puppet"}.call(t.prototype),g.Mode=t}),ace.require(["ace/mode/puppet"],function(i){"object"==typeof module&&"object"==typeof exports&&module&&(module.exports=i)});